Imports System.Net
Imports System.Net.Sockets
Imports System.Text.Encoding
Imports System.Threading

Public Class CMySckClient
    Public Const iServerPort As Integer = 9000

    Dim sckClient As New Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp)
    Dim RecvThread As Thread
    Dim objParent As CMySckServer
    Dim objForm As Form1
    Dim bIsConnect As Boolean
    Public qque As Queue = New Queue()

    Public Sub New(ByRef s As Socket)
        sckClient = s
        bIsConnect = False
        RecvThread = New Thread(AddressOf Recv)
        RecvThread.Start()
    End Sub

    Public Sub New(ByVal strServerIP As String)
        Dim hostip As IPAddress = Dns.Resolve(strServerIP).AddressList(0)
        Dim ephost As New IPEndPoint(hostip, iServerPort)

        sckClient.Connect(ephost)
        bIsConnect = True
        RecvThread = New Thread(AddressOf Recv)
        RecvThread.Start()
    End Sub

    Public Sub Recv()
        Dim bufbytes(1024) As Byte
        Dim strrecv As String

        While True
            sckClient.Receive(bufbytes, 1024, 0)
            strrecv = ASCII.GetChars(bufbytes)
            bufbytes.Clear(bufbytes, 0, 1024)
            If bIsConnect = False And strrecv <> "" Then
                qque.Enqueue(strrecv)
                'objParent.qque.Enqueue(strrecv.ToString)
            ElseIf bIsConnect = True And strrecv <> "" Then
                qque.Enqueue(strrecv)
            End If
        End While
    End Sub

    Public Sub Send(ByVal strsend As String)
        Dim bytesend As Byte() = ASCII.GetBytes(strsend)
        Dim iSend As Integer
        'MessageBox.Show(" Ŭ̾Ʈ ̴" & strsend)
        iSend = sckClient.Send(bytesend, strsend.Length, SocketFlags.None)
    End Sub

    Public Sub Close()
        sckClient.Shutdown(SocketShutdown.Both)
    End Sub

    Public Sub SetParent(ByRef ObjectParent As Object)
        objParent = ObjectParent
    End Sub

    Public Sub SetForm(ByRef ObjectForm As Object)
        objForm = ObjectForm
    End Sub

    Protected Overrides Sub Finalize()
        RecvThread.Abort()
    End Sub

End Class
