Imports System.Threading
Imports System.Net.Sockets

Public Structure MABLEC
    Dim strName As String
    Dim iPosition As Integer
    Dim iWillPosition As Integer
    Dim objcharacter As PictureBox
    Dim bIsFront As Boolean
End Structure

Public Structure GAME
    Dim bIsGaming As Boolean
    Dim iMe As Integer
    Dim iOrder As Integer
    Dim iCurUser As Integer
End Structure

Public Class Form1
    Inherits System.Windows.Forms.Form

    Public Const BOARDEND As Integer = 100
    Public Const BOARDBACK1 As Integer = -1
    Public Const BOARDBACK2 As Integer = -2
    Public Const BOARDBACK3 As Integer = -3
    Public Const BOARDFRONT1 As Integer = 1
    Public Const BOARDFRONT2 As Integer = 2
    Public Const BOARDFRONT3 As Integer = 3
    Public Const BOARDGOTOSTART As Integer = -100
    Public Const MOVEC As Integer = 75
    Public Const PICCHARACTER1_X As Integer = 627
    Public Const PICCHARACTER1_Y As Integer = 472
    Public Const PICGAPX As Integer = 24

    Public Shared sGame As GAME
    Public sMablec(3) As MABLEC
    Dim iBoard() As Integer = {0, 0, BOARDBACK1, 0, 0, BOARDBACK2, _
                                0, 0, 0, BOARDFRONT3, 0, 0, _
                                BOARDGOTOSTART, 0, BOARDFRONT2, 0, 0, 0, _
                                0, BOARDFRONT1, 0, BOARDGOTOSTART, 0, BOARDBACK3, BOARDEND}
    Dim cllcharacter As New Collection()
    Dim qque As Queue = New Queue()
    Dim sckServer As CMySckServer
    Dim sckClient As CMySckClient
    Dim bIsServer As Boolean
    Dim ActionThread As Thread

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents piccharacter1 As System.Windows.Forms.PictureBox
    Friend WithEvents PictureBox1 As System.Windows.Forms.PictureBox
    Friend WithEvents piccharacter3 As System.Windows.Forms.PictureBox
    Friend WithEvents piccharacter2 As System.Windows.Forms.PictureBox
    Friend WithEvents txtdie As System.Windows.Forms.TextBox
    Friend WithEvents btnstart As System.Windows.Forms.Button
    Friend WithEvents btnrundie As System.Windows.Forms.Button
    Friend WithEvents btnClientStart As System.Windows.Forms.Button
    Friend WithEvents btnServerStart As System.Windows.Forms.Button
    Public WithEvents txtmsg As System.Windows.Forms.TextBox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(Form1))
        Me.piccharacter1 = New System.Windows.Forms.PictureBox()
        Me.PictureBox1 = New System.Windows.Forms.PictureBox()
        Me.piccharacter3 = New System.Windows.Forms.PictureBox()
        Me.piccharacter2 = New System.Windows.Forms.PictureBox()
        Me.txtdie = New System.Windows.Forms.TextBox()
        Me.btnstart = New System.Windows.Forms.Button()
        Me.btnrundie = New System.Windows.Forms.Button()
        Me.btnClientStart = New System.Windows.Forms.Button()
        Me.btnServerStart = New System.Windows.Forms.Button()
        Me.txtmsg = New System.Windows.Forms.TextBox()
        Me.SuspendLayout()
        '
        'piccharacter1
        '
        Me.piccharacter1.BackColor = System.Drawing.Color.Black
        Me.piccharacter1.Image = CType(resources.GetObject("piccharacter1.Image"), System.Drawing.Bitmap)
        Me.piccharacter1.Location = New System.Drawing.Point(627, 472)
        Me.piccharacter1.Name = "piccharacter1"
        Me.piccharacter1.Size = New System.Drawing.Size(24, 23)
        Me.piccharacter1.TabIndex = 2
        Me.piccharacter1.TabStop = False
        '
        'PictureBox1
        '
        Me.PictureBox1.BackColor = System.Drawing.Color.Black
        Me.PictureBox1.Image = CType(resources.GetObject("PictureBox1.Image"), System.Drawing.Bitmap)
        Me.PictureBox1.Name = "PictureBox1"
        Me.PictureBox1.Size = New System.Drawing.Size(800, 600)
        Me.PictureBox1.TabIndex = 0
        Me.PictureBox1.TabStop = False
        '
        'piccharacter3
        '
        Me.piccharacter3.BackColor = System.Drawing.Color.Black
        Me.piccharacter3.Image = CType(resources.GetObject("piccharacter3.Image"), System.Drawing.Bitmap)
        Me.piccharacter3.Location = New System.Drawing.Point(675, 472)
        Me.piccharacter3.Name = "piccharacter3"
        Me.piccharacter3.Size = New System.Drawing.Size(24, 23)
        Me.piccharacter3.TabIndex = 1
        Me.piccharacter3.TabStop = False
        '
        'piccharacter2
        '
        Me.piccharacter2.BackColor = System.Drawing.Color.Black
        Me.piccharacter2.Image = CType(resources.GetObject("piccharacter2.Image"), System.Drawing.Bitmap)
        Me.piccharacter2.Location = New System.Drawing.Point(651, 472)
        Me.piccharacter2.Name = "piccharacter2"
        Me.piccharacter2.Size = New System.Drawing.Size(24, 23)
        Me.piccharacter2.TabIndex = 3
        Me.piccharacter2.TabStop = False
        '
        'txtdie
        '
        Me.txtdie.Location = New System.Drawing.Point(512, 240)
        Me.txtdie.Name = "txtdie"
        Me.txtdie.Size = New System.Drawing.Size(104, 21)
        Me.txtdie.TabIndex = 4
        Me.txtdie.TabStop = False
        Me.txtdie.Text = ""
        '
        'btnstart
        '
        Me.btnstart.Location = New System.Drawing.Point(512, 408)
        Me.btnstart.Name = "btnstart"
        Me.btnstart.Size = New System.Drawing.Size(104, 32)
        Me.btnstart.TabIndex = 6
        Me.btnstart.Text = ""
        '
        'btnrundie
        '
        Me.btnrundie.Enabled = False
        Me.btnrundie.Location = New System.Drawing.Point(512, 368)
        Me.btnrundie.Name = "btnrundie"
        Me.btnrundie.Size = New System.Drawing.Size(104, 32)
        Me.btnrundie.TabIndex = 5
        Me.btnrundie.Text = "ֻ "
        '
        'btnClientStart
        '
        Me.btnClientStart.Location = New System.Drawing.Point(192, 320)
        Me.btnClientStart.Name = "btnClientStart"
        Me.btnClientStart.Size = New System.Drawing.Size(120, 32)
        Me.btnClientStart.TabIndex = 9
        Me.btnClientStart.Text = "Ŭ̾Ʈ ŸƮ"
        '
        'btnServerStart
        '
        Me.btnServerStart.Location = New System.Drawing.Point(192, 280)
        Me.btnServerStart.Name = "btnServerStart"
        Me.btnServerStart.Size = New System.Drawing.Size(120, 32)
        Me.btnServerStart.TabIndex = 8
        Me.btnServerStart.Text = "ŸƮ"
        '
        'txtmsg
        '
        Me.txtmsg.Location = New System.Drawing.Point(192, 248)
        Me.txtmsg.Name = "txtmsg"
        Me.txtmsg.Size = New System.Drawing.Size(120, 21)
        Me.txtmsg.TabIndex = 7
        Me.txtmsg.Text = ""
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(6, 14)
        Me.ClientSize = New System.Drawing.Size(794, 599)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.btnClientStart, Me.btnServerStart, Me.txtmsg, Me.btnstart, Me.btnrundie, Me.txtdie, Me.piccharacter2, Me.piccharacter1, Me.piccharacter3, Me.PictureBox1})
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle
        Me.MaximizeBox = False
        Me.Name = "Form1"
        Me.Text = "Form1"
        Me.ResumeLayout(False)

    End Sub

#End Region

    ' ʱȭ Ѵ
    Private Sub Init_Game()
        Static bIsFirst As Boolean = True

        If bIsFirst = True Then
            sGame.iCurUser = 1
            With cllcharacter
                .Add(piccharacter1)
                .Add(piccharacter2)
                .Add(piccharacter3)
            End With
            bIsFirst = False
        End If

        With sGame
            '.iMe = 0
            .bIsGaming = True
            .iOrder = 0
        End With

        With sMablec(0)
            .strName = ""
            .iPosition = 0
            .iWillPosition = 0
            .objcharacter = piccharacter1
            .objcharacter.Left = PICCHARACTER1_X
            .objcharacter.Top = PICCHARACTER1_Y
            .bIsFront = True
        End With
        With sMablec(1)
            .strName = ""
            .iPosition = 0
            .iWillPosition = 0
            .objcharacter = piccharacter2
            .objcharacter.Left = PICCHARACTER1_X + PICGAPX
            .objcharacter.Top = PICCHARACTER1_Y
            .bIsFront = True
        End With
        With sMablec(2)
            .strName = "ֹ"
            .iPosition = 0
            .iWillPosition = 0
            .objcharacter = piccharacter3
            .objcharacter.Left = PICCHARACTER1_X + PICGAPX * 2
            .objcharacter.Top = PICCHARACTER1_Y
            .bIsFront = True
        End With

        btnstart.Enabled = False
        'btnrundie.Enabled = True
    End Sub

    Private Sub End_Game()
        'sGame.iCurUser = 1

        With sGame
            .iMe = -1
            .bIsGaming = True
            .iOrder = -1
        End With
        With sMablec(0)
            .strName = ""
            .iPosition = 0
            .iWillPosition = 0
            .bIsFront = True
        End With
        With sMablec(1)
            .strName = ""
            .iPosition = 0
            .iWillPosition = 0
            .bIsFront = True
        End With
        With sMablec(2)
            .strName = ""
            .iPosition = 0
            .iWillPosition = 0
            .bIsFront = True
        End With

        qque.Clear()
        btnstart.Enabled = True
        btnrundie.Enabled = False
    End Sub

    'ֻ 
    Private Function RunDie() As Integer
        Dim iDie As Integer
        Randomize()
        iDie = CInt(Int((6 * Rnd()) + 1))
        Return iDie
    End Function

    'ĳ͸ ű
    Private Sub MoveFirstActionCharacter(ByVal iCharacter As Integer, ByVal iMove As Integer)
        Dim strTemp As String
        Dim i, iGap As Integer

        sMablec(iCharacter).iWillPosition += iMove
        If sMablec(iCharacter).iWillPosition > 24 Then
            sMablec(iCharacter).iWillPosition = 24
        End If

        iGap = sMablec(iCharacter).iWillPosition - sMablec(iCharacter).iPosition

        For i = 1 To iGap
            qque.Enqueue(sMablec(iCharacter).iPosition + i)
        Next
    End Sub

    Private Sub MoveSecondActionCharacter(ByVal iCharacter As Integer)
        Dim strTemp As String
        Dim i, iGap As Integer

        Select Case (iBoard(sMablec(iCharacter).iPosition))
            Case BOARDBACK1, BOARDBACK2, BOARDBACK3
                sMablec(iCharacter).bIsFront = False
                sMablec(iCharacter).iWillPosition += iBoard(sMablec(iCharacter).iWillPosition)
                iGap = System.Math.Abs(sMablec(iCharacter).iWillPosition - sMablec(iCharacter).iPosition)
                For i = 1 To iGap
                    qque.Enqueue(sMablec(iCharacter).iPosition - i)
                Next
                MessageBox.Show("ڷ ")

            Case BOARDFRONT1, BOARDFRONT2, BOARDFRONT3
                sMablec(iCharacter).bIsFront = True
                sMablec(iCharacter).iWillPosition += iBoard(sMablec(iCharacter).iWillPosition)
                iGap = System.Math.Abs(sMablec(iCharacter).iWillPosition - sMablec(iCharacter).iPosition)
                For i = 1 To iGap
                    qque.Enqueue(sMablec(iCharacter).iPosition + i)
                Next
                MessageBox.Show(" ")

            Case BOARDGOTOSTART
                sMablec(iCharacter).objcharacter.Left = 627 + (iCharacter * PICGAPX)
                sMablec(iCharacter).objcharacter.Top = 472
                MessageBox.Show(" ")
                sMablec(iCharacter).iPosition = 0
                sMablec(iCharacter).iWillPosition = 0
                System.Threading.Thread.Sleep(1000)

            Case BOARDEND
                If sGame.iMe = iCharacter Then
                    MessageBox.Show("ϰ ̰")
                Else
                    strTemp = sMablec(iCharacter).strName + " ̰"
                    MessageBox.Show(strTemp)
                End If
                End_Game()
        End Select
    End Sub

    'ȭ ĳ͸ ű
    Private Sub Calcharacter(ByVal icharacter As Integer, ByVal imove As Integer)
        If sMablec(icharacter).bIsFront = True Then
            If sMablec(icharacter).iPosition >= 0 And sMablec(icharacter).iPosition < 5 Then
                sMablec(icharacter).objcharacter.Top += (MOVEC * -1)
            ElseIf sMablec(icharacter).iPosition >= 5 And sMablec(icharacter).iPosition < 12 Then
                sMablec(icharacter).objcharacter.Left += (MOVEC * -1)
            ElseIf sMablec(icharacter).iPosition >= 12 And sMablec(icharacter).iPosition < 17 Then
                sMablec(icharacter).objcharacter.Top += MOVEC
            ElseIf sMablec(icharacter).iPosition >= 17 And sMablec(icharacter).iPosition < 24 Then
                sMablec(icharacter).objcharacter.Left += MOVEC
            End If
        Else
            If sMablec(icharacter).iPosition >= 0 And sMablec(icharacter).iPosition <= 5 Then
                sMablec(icharacter).objcharacter.Top += MOVEC
            ElseIf sMablec(icharacter).iPosition > 5 And sMablec(icharacter).iPosition <= 12 Then
                sMablec(icharacter).objcharacter.Left += MOVEC
            ElseIf sMablec(icharacter).iPosition > 12 And sMablec(icharacter).iPosition <= 17 Then
                sMablec(icharacter).objcharacter.Top += (MOVEC * -1)
            ElseIf sMablec(icharacter).iPosition > 17 And sMablec(icharacter).iPosition <= 24 Then
                sMablec(icharacter).objcharacter.Left += (MOVEC * -1)
            End If
        End If

    End Sub

    Private Sub btnrundie_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnrundie.Click
        Dim iMove As Integer

        If sGame.iOrder = sGame.iMe Then
            If bIsServer = True Then
                iMove = ActionDie()
                sckServer.Send(CStr(iMove))
            Else
                iMove = RunDie()
                sckClient.Send(CStr(iMove))
            End If
        End If
    End Sub

    ' ߻Ѽ óϴ Լ
    Private Function ActionDie() As Integer
        Dim iMove, i, iCurPosition, iRet As Integer

        iRet = RunDie()
        txtdie.Text = CStr(iRet)
        MoveFirstActionCharacter(sGame.iOrder, iRet)
        iMove = qque.Count
        For i = 1 To iMove
            iCurPosition = qque.Dequeue()
            Calcharacter(sGame.iOrder, iCurPosition)
            sMablec(sGame.iOrder).iPosition = iCurPosition
            System.Threading.Thread.Sleep(100)
        Next

        MoveSecondActionCharacter(sGame.iOrder)
        While qque.Count <> 0
            iMove = qque.Count
            If iMove <> 0 Then
                For i = 1 To iMove
                    iCurPosition = qque.Dequeue()
                    Calcharacter(sGame.iOrder, iCurPosition)
                    sMablec(sGame.iOrder).iPosition = iCurPosition
                    System.Threading.Thread.Sleep(100)
                Next
                sMablec(sGame.iOrder).bIsFront = True
            End If
            MoveSecondActionCharacter(sGame.iOrder)
        End While

        sGame.iOrder += 1
        If sGame.iOrder > 2 Then
            sGame.iOrder = 0
        End If
        If sGame.iOrder = sGame.iMe Then
            btnrundie.Enabled = True
        Else
            btnrundie.Enabled = False
        End If

        Return iRet
    End Function

    ' ߻ ޾Ƽ óϴ Լ
    Private Sub ActionDie(ByVal iMove As Integer)
        Dim i, iCurPosition, iRet As Integer

        txtdie.Text = CStr(iMove)
        MoveFirstActionCharacter(sGame.iOrder, iMove)
        iMove = qque.Count
        For i = 1 To iMove
            iCurPosition = qque.Dequeue()
            Calcharacter(sGame.iOrder, iCurPosition)
            sMablec(sGame.iOrder).iPosition = iCurPosition
            System.Threading.Thread.Sleep(100)
        Next

        MoveSecondActionCharacter(sGame.iOrder)
        While qque.Count <> 0
            iMove = qque.Count
            If iMove <> 0 Then
                For i = 1 To iMove
                    iCurPosition = qque.Dequeue()
                    Calcharacter(sGame.iOrder, iCurPosition)
                    sMablec(sGame.iOrder).iPosition = iCurPosition
                    System.Threading.Thread.Sleep(100)
                Next
                sMablec(sGame.iOrder).bIsFront = True
            End If
            MoveSecondActionCharacter(sGame.iOrder)
        End While

        sGame.iOrder += 1
        If sGame.iOrder > 2 Then
            sGame.iOrder = 0
        End If

        txtmsg.Text = CStr(sGame.iOrder)
        If sGame.iOrder = sGame.iMe Then
            btnrundie.Enabled = True
        Else
            btnrundie.Enabled = False
        End If
    End Sub

    Private Sub btnstart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnstart.Click
        Init_Game()
        btnrundie.Enabled = True
    End Sub



    Private Sub btnServerStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnServerStart.Click
        bIsServer = True
        sckServer = New CMySckServer()
        sckServer.Create()
        sckServer.SetParentForm(Me)
        sGame.iMe = 0

        ActionThread = New Thread(AddressOf ActRecvServer)
        ActionThread.Start()
        btnServerStart.Enabled = False
        btnClientStart.Enabled = False
    End Sub



    Private Sub btnClientStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClientStart.Click
        bIsServer = False
        sckClient = New CMySckClient("127.0.0.1")
        sckClient.SetForm(Me)

        ActionThread = New Thread(AddressOf ActRecvClient)
        ActionThread.Start()

        btnServerStart.Enabled = False
        btnClientStart.Enabled = False
        btnstart.Enabled = False
    End Sub

    Private Sub ActRecvServer()
        Dim sckTempServer As CMySckClient
        Dim strMove As String

        While True
            For Each sckTempServer In sckServer.cllSocket
                If sckTempServer.qque.Count <> 0 Then
                    strMove = sckTempServer.qque.Dequeue()
                    ActionDie(CInt(strMove))
                    sckServer.Send(strMove)
                    strMove = ""
                End If
            Next
            System.Threading.Thread.Sleep(100)
        End While
    End Sub

    Private Sub ActRecvClient()
        Static bIsFirst As Boolean = True
        Dim strMove As String

        While True
            If sckClient.qque.Count <> 0 Then
                If bIsFirst = True Then
                    sGame.iMe = sckClient.qque.Dequeue()
                    txtmsg.Text = CStr(sGame.iMe)
                    Init_Game()
                    bIsFirst = False
                Else
                    strMove = sckClient.qque.Dequeue()
                    If strMove.Compare(strMove, "") <> 0 Then
                        ActionDie(CInt(strMove))
                    End If
                    strMove = ""
                End If
            End If

            System.Threading.Thread.Sleep(100)
        End While
    End Sub

    Private Sub txtmsg_KeyPress(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles txtmsg.KeyPress
        If e.KeyChar = Microsoft.VisualBasic.ChrW(13) Then
            If bIsServer = True Then
                sckServer.Send(txtmsg.Text)
            Else
                sckClient.Send(txtmsg.Text)
            End If
            txtmsg.Text = ""
        End If
    End Sub

    Protected Overrides Sub Finalize()
        ActionThread.Abort()
    End Sub
End Class
